Attribute VB_Name = "Mod_Plat1"
Option Explicit

Public strEHL As String, strEHF As String
Public strProjekt As String, strPosition As String
Public strDateiName As String

Public nx As Integer, ny As Integer, nzx As Integer, nzy As Integer
Public EMod As Single, t As Single, h0 As Single
Public mue As Single, pz As Single, lx As Single, ly As Single
Public c As Single, d As Single, u As Single, v As Single
Public W() As Single, W0() As Single
Public pT() As Single
Public blnLastDarst As Boolean
Public WZ() As Single, MX() As Single, MY() As Single
Public MXY() As Single, QX() As Single, QY() As Single
Public AX() As Single, AY() As Single
Public Gr() As Single
Public dx As Single, dy As Single
Public strLinie(7) As String

Public maxpT As Single
Public iy_pTmax As Integer, ix_pTmax As Integer

Public maxwz As Single
Public iy_wmax As Integer, ix_wmax As Integer

Public maxMx As Single
Public iy_Mxmax As Integer, ix_Mxmax As Integer

Public maxMy As Single
Public iy_Mymax As Integer, ix_Mymax As Integer

Public maxMxy As Single
Public iy_Mxymax As Integer, ix_Mxymax As Integer

Public maxQx As Single
Public iy_Qxmax As Integer, ix_Qxmax As Integer

Public maxQy As Single
Public iy_Qymax As Integer, ix_Qymax As Integer

Public Const strPgmName = "Plat1.vbp"
Public Const strVersion = "5.1"
Const pi = 3.14159
 
Public Sub Hauptprogramm()
'verwendete Variablennamen:
'Eingabe:    NX,NY,Emod,T,mue,pz,lx,ly,C,D,U,V,nzx,nzy
'Gren:     K,SU,SC,W2,dx,dy
'            x,y,S1-S7,SI,CI,SJ,CJ,EP,I,J,ix,iy
'Ergebnisse: W,WZ,MX,MY,MXY,QX,QY,AX,AY
'Version 5.1, 23.08.2012
'   Sub Plotten_Sys: Grafik Lastrechteck korrigiert
'   Sub Plotten_Ord: Farben Schnittgren pos.= blau, neg.= rot
'   Sub Hauptprogramm: Indizes iy, ix -> ix, iy, nzx+1, nzy+1
'   Sub Dimensionierung: Indizes um 1 erhht
Dim K As Single, SU As Single, SC As Single, W2 As Single
Dim x As Single, y As Single
Dim S0 As Single, S1 As Single, S2 As Single, S3 As Single, S4 As Single
Dim S5 As Single, S6 As Single, S7 As Single
Dim SI As Single, CI As Single, SJ As Single, CJ As Single
Dim EP As Single
Dim i As Integer, j As Integer, ix As Integer, iy As Integer

Call Dimensionierung

strLinie(1) = "(Teilflchen)Belastung pT"   '5.1
strLinie(2) = "Biegelinie w"
strLinie(3) = "Biegemomente mx"
strLinie(4) = "Biegemomente my"
strLinie(5) = "Torsionsmomente mxy"
strLinie(6) = "Querkrfte qx"
strLinie(7) = "Querkrfte qy"

K = EMod * t ^ 3 / (1 - mue ^ 2) / 12
For i = 1 To nx
  SU = Sin(i * pi * u / lx): SC = Sin(i * pi * c / lx)
  For j = 1 To ny
    W2 = 16 * pz / pi ^ 2 / i / j * SU * SC * Sin(j * pi * v / ly) * Sin(j * pi * d / ly)
    W0(i, j) = W2
    W(i, j) = W2 / K / pi ^ 4 / (i * i / lx ^ 2 + j * j / ly ^ 2) ^ 2
  Next j
Next i

'Durchbiegung, Biegemomente, Querkrfte - - - - - - - - - - - - - - - -
dx = lx / (nzx - 1): dy = ly / (nzy - 1)
maxpT = 0: maxwz = 0: maxMx = 0: maxMy = 0: maxMxy = 0
For ix = 1 To nzx + 1           '5.1
  x = (ix - 1) * dx
  For iy = 1 To nzy + 1         '5.1
    y = (iy - 1) * dy
    S0 = 0: S1 = 0: S2 = 0: S3 = 0: S4 = 0: S5 = 0: S6 = 0
    For i = 1 To nx
      SI = Sin(i * pi * x / lx): CI = Cos(i * pi * x / lx)
      For j = 1 To ny
        SJ = Sin(j * pi * y / ly): CJ = Cos(j * pi * y / ly)
        S0 = S0 + W0(i, j) * SI * SJ
        S1 = S1 + W(i, j) * SI * SJ
        S2 = S2 + W(i, j) * K * pi ^ 2 * (i ^ 2 / lx ^ 2 + mue * j ^ 2 / ly ^ 2) * SI * SJ
        S3 = S3 + W(i, j) * K * pi ^ 2 * (j ^ 2 / ly ^ 2 + mue * i ^ 2 / lx ^ 2) * SI * SJ
        S4 = S4 - W(i, j) * K * (1 - mue) * pi ^ 2 * i * j / lx / ly * CI * CJ
        S5 = S5 + W(i, j) * K * pi ^ 3 * (i ^ 2 / lx ^ 2 + j ^ 2 / ly ^ 2) * i / lx * CI * SJ
        S6 = S6 + W(i, j) * K * pi ^ 3 * (i ^ 2 / lx ^ 2 + j ^ 2 / ly ^ 2) * j / ly * SI * CJ
      Next j
    Next i
    pT(ix, iy) = S0               '5.1
    WZ(ix, iy) = S1               '5.1
    MX(ix, iy) = S2               '5.1
    MY(ix, iy) = S3               '5.1
    MXY(ix, iy) = S4              '5.1
    QX(ix, iy) = S5               '5.1
    QY(ix, iy) = S6               '5.1
    
    'Maxima und Stellen ix, iy         '5.1
    If maxpT < Abs(pT(ix, iy)) Then maxpT = Abs(pT(ix, iy)): iy_pTmax = iy: ix_pTmax = ix
    If maxwz < Abs(WZ(ix, iy)) Then maxwz = Abs(WZ(ix, iy)): iy_wmax = iy: ix_wmax = ix
    If maxMx < Abs(MX(ix, iy)) Then maxMx = Abs(MX(ix, iy)): iy_Mxmax = iy: ix_Mxmax = ix
    If maxMy < Abs(MY(ix, iy)) Then maxMy = Abs(MY(ix, iy)): iy_Mymax = iy: ix_Mymax = ix
    If maxMxy < Abs(MXY(ix, iy)) Then maxMxy = Abs(MXY(ix, iy)): iy_Mxymax = iy: ix_Mxymax = ix
    If maxQx < Abs(QX(ix, iy)) Then maxQx = Abs(QX(ix, iy)): iy_Qxmax = iy: ix_Qxmax = ix
    If maxQy < Abs(QY(ix, iy)) Then maxQy = Abs(QY(ix, iy)): iy_Qymax = iy: ix_Qymax = ix
    
  Next iy
Next ix

'Auflagerkrfte Ax - - - - - - - - - - - - - - - - - - - - - - - - - - -
For ix = 1 To 2
  x = (ix - 1) * lx
  For iy = 1 To nzy + 1      '5.1
    y = (iy - 1) * dy: S7 = 0
    For i = 1 To nx
      CI = Cos(i * pi * x / lx)
      For j = 1 To ny
        SJ = Sin(j * pi * y / ly)
        S7 = S7 + W(i, j) * K * pi ^ 3 * (i ^ 2 / lx ^ 2 + _
                 (2 - mue) * j ^ 2 / ly ^ 2) * i / lx * CI * SJ
      Next j
    Next i
    AX(ix, iy) = S7
  Next iy
Next ix

'Auflagerkrfte Ay - - - - - - - - - - - - - - - - - - - - - - - - - - -
For ix = 1 To nzx + 1      '5.1
  x = (ix - 1) * dx
  For iy = 1 To 2
    y = (iy - 1) * ly
    S7 = 0
    For i = 1 To nx
      SI = Sin(i * pi * x / lx)
      For j = 1 To ny
        CJ = Cos(j * pi * y / ly)
        S7 = S7 + W(i, j) * K * pi ^ 3 * ((2 - mue) * i ^ 2 / lx ^ 2 + _
                  j ^ 2 / ly ^ 2) * j / ly * SI * CJ
      Next j
    Next i
    AY(ix, iy) = S7
  Next iy
Next ix

End Sub

Public Sub Ergebnis_Grid1()
'Ergebnisse in Tabelle anzeigen
Dim ix As Integer, iy As Integer, IReihe As Integer
Dim x As Single, y As Single

With frm_Plat1.MSFlexGrid1
  .Clear
  'Zellenzahl und -gren
  .ScrollBars = 3
  .Rows = nzx * nzy + 2
  .Cols = 8
  .FixedRows = 2
  .FixedCols = 2
  .Width = frm_Plat1.Frame3.Width - 600
  .ColWidth(0) = .Width * 0.1
  .ColWidth(1) = .Width * 0.1
  For ix = 2 To 7
    .ColWidth(ix) = .Width * 0.12
  Next ix
  .Font = "arial"

  'berschriften
  .Row = 0
  .Col = 2: .Text = "w"
  .Col = 3: .Text = "mx"
  .Col = 4: .Text = "my"
  .Col = 5: .Text = "mxy"
  .Col = 6: .Text = "qx"
  .Col = 7: .Text = "qy"
  
  .Row = 1
  .Col = 0: .Text = "x"
  .Col = 1: .Text = "y"
  .Col = 2
  If strEHL = "m" Then
    .Text = "mm"
  Else
    .Text = strEHL
  End If
  .Col = 3: .Text = strEHF + strEHL + "/" + strEHL
  .Col = 4: .Text = strEHF + strEHL + "/" + strEHL
  .Col = 5: .Text = strEHF + strEHL + "/" + strEHL
  .Col = 6: .Text = strEHF + "/" + strEHL
  .Col = 7: .Text = strEHF + "/" + strEHL
  
  .ForeColorSel = RGB(255, 0, 0)
  
  'Daten
  For ix = 1 To nzx
    x = (ix - 1) * dx
    IReihe = (ix - 1) * nzy + 1
    For iy = 1 To nzy
      y = (iy - 1) * dy
      .Row = IReihe + iy
      .Col = 0
      If iy = 1 Then .Text = Format(x, "0.00 ")
      .Col = 1
      .Text = Format(y, "0.00 ")
      .Col = 2
      .Text = Format(WZ(ix, iy) * 1000, "0.000 ")   '5.1
      .Col = 3
      .Text = Format(MX(ix, iy), "0.000 ")          '5.1
      .Col = 4
      .Text = Format(MY(ix, iy), "0.000 ")          '5.1
      .Col = 5
      .Text = Format(MXY(ix, iy), "0.000 ")         '5.1
      .Col = 6
      .Text = Format(QX(ix, iy), "0.000 ")          '5.1
      .Col = 7
      .Text = Format(QY(ix, iy), "0.000 ")          '5.1
    Next iy
  Next ix
End With

End Sub

Public Sub Maximalwerte_Grid()
'Farbliche Markierung max w, ix_wmax = Stelle in x-Richtung
With frm_Plat1.MSFlexGrid1
  'max w
  .Col = 2:  .ColSel = 3
  .Row = iy_wmax * nzy - ix_wmax + 1
  .RowSel = .Row + 1
  .ForeColorSel = RGB(255, 255, 255)
  .BackColorSel = RGB(0, 255, 0)
  Call Pause(1)
  
  'max mx
  .Col = 3:  .ColSel = 4
  .Row = iy_Mxmax * nzy - ix_Mxmax + 1
  .RowSel = .Row + 1
  .ForeColorSel = RGB(255, 255, 255)
  .BackColorSel = RGB(255, 0, 0)
  Call Pause(1)
  
  'max my
  .Col = 4:  .ColSel = 5
  .Row = iy_Mymax * nzy - ix_Mymax + 1
  .RowSel = .Row + 1
  .ForeColorSel = RGB(255, 255, 255)
  .BackColorSel = RGB(255, 0, 0)
  Call Pause(1)
  
  'max mxy
  .Col = 5:  .ColSel = 6
  .Row = iy_Mxymax * nzy - ix_Mxymax + 1
  .RowSel = .Row + 1
  .ForeColorSel = RGB(255, 255, 255)
  .BackColorSel = RGB(255, 0, 0)
  Call Pause(1)
  
  'max qx
  .Col = 6:  .ColSel = 7
  .Row = iy_Qxmax * nzy - ix_Qxmax + 1
  .RowSel = .Row + 1
  .ForeColorSel = RGB(255, 255, 255)
  .BackColorSel = RGB(0, 0, 255)
  Call Pause(1)
  
  'max qy
  .Col = 7
  .Row = iy_Qymax * nzy - ix_Qymax + 1
  .RowSel = .Row + 1
  .ForeColorSel = RGB(255, 255, 255)
  .BackColorSel = RGB(0, 0, 255)
  Call Pause(1)
End With

End Sub

Public Sub Vorbelegung()
  strEHL = "m": strEHF = "kN"
  strProjekt = "Test": strPosition = "1"
  strDateiName = App.Path + "\" + "..."
  EMod = 21000000#
  blnLastDarst = False
  
  'Beispiel 1
  t = 0.01
  mue = 0
  pz = 10
  lx = 1
  ly = 2
  c = 0.5
  d = 0.5
  u = 0.5
  v = 0.5
  nx = 1: ny = 1
  nzx = 3: nzy = 3
  Verx = 0.4: Very = 0.6
  
  'Beispiel 2
  t = 0.01
  mue = 0
  pz = 5
  lx = 1
  ly = 5
  c = 0.5
  d = 0.1
  u = 0.5
  v = 2.5
  nx = 1: ny = 1
  nzx = 3: nzy = 3
  Verx = 0.4: Very = 0.6
  
  'Beispiel 3
  t = 0.2
  mue = 0.16667
  pz = 1
  lx = 10
  ly = 9
  c = 1.5
  d = 1.25
  u = 4.5
  v = 5.25
  nx = 20: ny = 20
  nzx = 10: nzy = 10
  Verx = 0.4: Very = 0.6
  'Exit Sub
  
  'Beispiel 4 Last nahe Usprung
  t = 0.2
  mue = 0.16667
  pz = 1
  lx = 10
  ly = 10
  c = 1
  d = 1
  u = 1
  v = 9
  nx = 20: ny = 20
  nzx = 10: nzy = 10
  Verx = 0.4: Very = 0.6

End Sub

Public Sub Dimensionierung()
  'Dimensionierung der Feldvariablen
  ReDim W(nx, ny) As Single, W0(nx, ny) As Single
  ReDim pT(nzx + 1, nzy + 1) As Single
  ReDim WZ(nzx + 1, nzy + 1) As Single, MX(nzx + 1, nzy + 1) As Single
  ReDim MY(nzx + 1, nzy + 1) As Single, MXY(nzx + 1, nzy + 1) As Single
  ReDim QX(nzx + 1, nzy + 1) As Single, QY(nzx + 1, nzy + 1) As Single
  ReDim AX(2, nzy + 1) As Single, AY(nzx + 1, 2) As Single
  ReDim Gr(0 To nzx, 0 To nzy) As Single
End Sub

Public Sub Pause(ByVal Zeit As Variant)
  'Pause in sek
  Dim Zeit1 As Variant
  Zeit1 = Timer
  Do
    DoEvents
    If Timer < Zeit1 Then Zeit = Zeit - 86400
  Loop Until (Timer - Zeit1 > Zeit)
End Sub
